#! /usr/bin/python

# fn = filename
# '<filename>'  -->  fn
# ' ---' --> fstem
# 'Module\n======' --> fstem\n=====

import os, sys

def main(fns=[]):
    if not fns:
        fns = [f for f in os.listdir(os.getcwd())
               if f.endswith('.py')
               and f not in ['fillin.py', '__init__.py']]
    for fn in fns:
        fstem = os.path.splitext(fn)[0]
        data = open(fn).read()
        data = data.replace('<filename>', fn)
        data = data.replace(' ---', ' %s' % fstem)
        underline = '=' * len(fstem)
        data = data.replace('Module\n======', '%s\n%s' % (fstem, underline))
        open(fn, 'w').write(data)

if __name__ == '__main__':
    main() # ['cymraeg.g2p', 'cymraeg.graphemeset', 'ipa.phoneset'])
