xml = """\
<?xml version="1.0" encoding="UTF-8"?>

<!-- iau 291007
     ant build file cribbed from sphinx4/build.xml
     -->

<project basedir="." default="all" name="Sphinx-4">

    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Where to find things...                                * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <property name="version"            value="1.0beta"/>

    <path id="libs">
        <fileset dir="lib" includes="**/jsapi.jar,**/js.jar"/>
    </path>

    <property name="src_dir"		value="TREFNYDD_S4_SRC_DIR"/>
    <property name="build_dir"		value="${src_dir}/bld"/>
    <property name="classes_dir"	value="${build_dir}/classes"/>
    <property name="lib_dir"            value="${src_dir}/lib"/>
    <property name="bin_dir"            value="${src_dir}/bin"/>
    <!-- property name="deploy_dir"         value="deploy"/ -->

    <property name="build_model_dir"
              value="${build_dir}/models/edu/cmu/sphinx/model/acoustic"/>
    <property name="model_class_dir"
              value="${src_dir}/edu/cmu/sphinx/model/acoustic"/>
    <property name="tiedstate_dir"
              value="${src_dir}/edu/cmu/sphinx/linguist/acoustic/tiedstate"/>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * For generating the models.                             * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->

    <!-- replace values with real names -->
    <property name="newAcousticModel_name"
              value="TREFNYDD_GENERATED_AM_NAME"/>
    <!-- value = AM name -->
    
    <property name="newAcousticModel_data_dir"
              value="TREFNYDD_GENERATED_AM_DATA_DIR"/>
    <!-- value = relative or absolute path to dir -->

    <!-- Load the environment -->
    <property environment="env"/>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Determine which sources should be compiled depending   * -->
    <!-- * on the availability of lib/jsapi.jar.  This creates a  * -->
    <!-- * property called "patternset_to_compile" and sets its   * -->
    <!-- * val to either "all_files" or "no_jsapi", which refers  * -->
    <!-- * to the name of a patternset. The value of              * -->
    <!-- * srcs_to_compile will be used in the javac target as a  * -->
    <!-- * patternset refid.                                      * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->


    <!-- TODO - we are excluding a number of packages temporarily
      from the build. This is a step along the road to refactoring
      the system. The excluded packages have not yet been refactored
      -->


    <patternset id="all_files" 
                includes="edu/**,com/**"
                excludes="edu/cmu/sphinx/research/distributed/**,
		edu/cmu/sphinx/research/bushderby/**,
                edu/cmu/sphinx/trainer/**,
                edu/cmu/sphinx/linguist/acoustic/tiedstate/trainer/**"
                />

    <patternset id="edu" 
                includes="edu/**"
	        excludes="com/**,
                edu/cmu/sphinx/research/distributed/**,
                edu/cmu/sphinx/research/bushderby/**,
                edu/cmu/sphinx/trainer/**,
                edu/cmu/sphinx/linguist/acoustic/tiedstate/trainer/**,
                "/>

    <patternset id="no_jsapi" 
                includes="edu/**"
	        excludes="com/**,
                edu/cmu/sphinx/research/**,
                edu/cmu/sphinx/trainer/**,
                edu/cmu/sphinx/linguist/acoustic/tiedstate/trainer/**,
                edu/cmu/sphinx/tools/tags/**,
                edu/cmu/sphinx/jsapi/**"/>
             
    <target name="set_patternset_to_compile">
        <condition property="patternset_to_compile"
                   value="all_files">
            <available file="${lib_dir}/jsapi.jar"/>
        </condition>
        <condition property="patternset_to_compile"
                   value="no_jsapi">
            <not>
                <available file="${lib_dir}/jsapi.jar"/>
            </not>
        </condition>
    </target>



    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Handle JSAPI:                                          * -->
    <!-- *                                                        * -->
    <!-- *    1) If a jsapi.jar file can be found, use it and     * --> 
    <!-- *       compile all the sources.                         * -->
    <!-- *                                                        * -->
    <!-- *    2) If a jsapi.jar file cannot be found, issue a     * -->
    <!-- *       message and just compile the sources that do     * -->
    <!-- *       not depend upon jsapi.jar.                       * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="check_jsapi_default.isPresent">
        <!-- Complicated way of doing a "if... else"                 -->
        <!-- Check if the environment variable is set. If it is, set -->
        <!-- the local variable to the same value.                   -->
        <condition property="EXTERNAL_JSAPI_LOCATION" 
                   value="${env.EXTERNAL_JSAPI_LOCATION}">
            <isset property="env.EXTERNAL_JSAPI_LOCATION"/>
        </condition>

        <!-- If environment variable is not set, set the local       -->
        <!-- variable to a default value.                            -->
        <condition property="EXTERNAL_JSAPI_LOCATION" 
                   value="/lab/speech/sphinx4/lib/jsapi.jar">
            <not>
                 <isset property="env.EXTERNAL_JSAPI_LOCATION"/>
            </not>
        </condition>
        <available file="${EXTERNAL_JSAPI_LOCATION}" 
                   property="jsapi_default.isPresent"/>
    </target>

    <target name="copy_jsapi_jar" if="jsapi_default.isPresent">
        <copy file="${EXTERNAL_JSAPI_LOCATION}" tofile="${lib_dir}/jsapi.jar"/>
    </target>

    <target name="check_jsapi_jar.isPresent"
            depends="check_jsapi_default.isPresent,copy_jsapi_jar">
        <available file="${lib_dir}/jsapi.jar" property="jsapi_jar.isPresent"/>
    </target>

    <target name="issue_jsapi_warning"
            unless="jsapi_jar.isPresent">
        <echo>

Cannot find lib/jsapi.jar needed to build Java Speech API
(JSAPI) support for Sphinx-4.  Will not build any sources
that require jsapi.jar.  If you'd like to enable JSAPI
support, please extract jsapi.jar by running jsapi.sh or 
jsapi.exe from the lib directory.
        </echo>
    </target>

    <target name="handle_jsapi"
            depends="check_jsapi_jar.isPresent,
                     issue_jsapi_warning,
                     set_patternset_to_compile"/>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Builds srcs, jars, demos                               * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="all"
	    description="Build everything">
	<antcall target="create_all_model_classes"/>
	<antcall target="compile_src"/>
	<mkdir dir="${build_model_dir}"/>
	<copy todir="${build_model_dir}">
	      <fileset dir="${classes_dir}/edu/cmu/sphinx/model/acoustic"/>
	</copy>
	<antcall target="create_all_models"/>
	<antcall target="jars"/>
	<echo message="Build complete."/>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Builds just the srcs.                                  * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="compile_src"
	    depends="handle_jsapi"
	    description="Build just the srcs">
	<mkdir dir="${classes_dir}"/>
	<javac debug="true"
	       source="1.4"
 	       srcdir="${src_dir}"
	       deprecation="true"
	       destdir="${classes_dir}">
            <patternset refid="${patternset_to_compile}"/>
	    <classpath refid="libs"/>
	</javac>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Generates the jar files                                * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="jars"
	    depends="sphinx4_jar,tags_jar,audiotool_jar"
	    description="Builds all the jar files"/>


    <!-- sphinx4.jar -->
    <property name="sphinx4_jar" value="${lib_dir}/sphinx4.jar"/>

    <target name="sphinx4_jar" 
	    depends="compile_src"
	    description="Create ${lib_dir}/sphinx4.jar">
        <mkdir dir="${lib_dir}"/>
        <jar destfile="${sphinx4_jar}" 
	     manifest="${src_dir}/edu/cmu/sphinx/sphinx4.manifest"
	     compress="true"
	     includes="edu/**,com/**"
             excludes="edu/cmu/sphinx/tools/**,com/sun/taglet/**"
	     basedir="${classes_dir}"/>
    </target>

    <!-- tags.jar -->
    <property name="tags_jar" value="${lib_dir}/tags.jar"/>

    <target name="tags_jar" 
	    depends="compile_src"
	    description="Create ${lib_dir}/tags.jar">
        <mkdir dir="${lib_dir}"/>
        <jar destfile="${tags_jar}" 
	     manifest="${src_dir}/edu/cmu/sphinx/tools/tags/Manifest"
	     compress="true"
	     includes="edu/cmu/sphinx/tools/tags/**"
	     basedir="${classes_dir}"/>
    </target>

    <!-- AudioTool.jar -->
    <property name="audiotool_jar" value="${bin_dir}/AudioTool.jar"/>

    <target name="audiotool_jar" 
	    depends="compile_src"
	    description="Create ${bin_dir}/AudioTool.jar">
        <mkdir dir="${bin_dir}"/>
        <jar destfile="${audiotool_jar}" 
	     manifest="${src_dir}/edu/cmu/sphinx/tools/audio/Manifest"
	     compress="true">
            <fileset dir="${classes_dir}"
		     includes="edu/cmu/sphinx/tools/audio/*"/>
            <fileset dir="${src_dir}"
		     includes="edu/cmu/sphinx/tools/audio/spectrogram.config.xml"/>
        </jar>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Generates an acoustic model JAR from a Sphinx-3 model  * -->
    <!-- * directory.                                             * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->

    <target name="s3_model_to_s4"
            description="Generates an acoustic model JAR from a Sphinx-3 model directory.">
        <antcall target="create_my_model_classes">
	    <param name="my_model_name" value="${model_name}"/>
        </antcall>
	<antcall target="compile_src"/>
	<mkdir dir="${build_model_dir}/${model_name}"/>
	<move todir="${build_model_dir}/${model_name}">
	      <fileset dir="${classes_dir}/edu/cmu/sphinx/model/acoustic/${model_name}"/>
	</move>
	<antcall target="create_my_model">
	    <param name="my_model_data_dir" value="${model_data_dir}"/>
	    <param name="my_model_name" value="${model_name}"/>
        </antcall>
	<antcall target="delete_my_model_classes">
	    <param name="my_model_name" value="${model_name}"/>
        </antcall>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Create/Delete the acoustic model class files.          * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->

    <target name="create_all_model_classes"
	    description="Creates all the model class files.">
	<antcall target="create_my_model_classes">
	<param name="my_model_name" value="${newAcousticModel_name}"/>
	</antcall>

    </target>

    <target name="delete_all_model_classes"
            description="Deletes the WSJ and TIDIGITS model classes.">
	<antcall target="delete_my_model_classes">
	<param name="my_model_name" value="${newAcousticModel_name}"/>
	</antcall>

    </target>

    <target name="delete_my_model_classes"
            description="Deletes the class files of a model.">
	<delete dir="${model_class_dir}/${my_model_name}/"/>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Creates the PropertiesDumper.java, Model.java and      * -->
    <!-- * ModelLoader.java for a particular acoustic model.      * -->
    <!-- * param: 'my_model_name'                                 * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="create_my_model_classes"
            description="Creates the model class files.">
	<mkdir dir="${model_class_dir}/${my_model_name}/"/>
	
	<copy file="${tiedstate_dir}/PropertiesDumper.java"
	  tofile="${model_class_dir}/${my_model_name}/PropertiesDumper.java"/>
	<replace
             file="${model_class_dir}/${my_model_name}/PropertiesDumper.java"
	     value="package edu.cmu.sphinx.model.acoustic.${my_model_name}">
	    <replacetoken>package edu.cmu.sphinx.linguist.acoustic.tiedstate</replacetoken>
	</replace>

        <copy file="${tiedstate_dir}/TiedStateAcousticModel.java"
	      tofile="${model_class_dir}/${my_model_name}/Model.java"/>
	<replace file="${model_class_dir}/${my_model_name}/Model.java"
	     value="package edu.cmu.sphinx.model.acoustic.${my_model_name}">
	    <replacetoken>package edu.cmu.sphinx.linguist.acoustic.tiedstate</replacetoken>
	</replace>
	<replace file="${model_class_dir}/${my_model_name}/Model.java"
	         value="Model">
	    <replacetoken>TiedStateAcousticModel</replacetoken>
	</replace>

	<mkdir dir="${model_class_dir}/${my_model_name}/"/>
        <copy file="${tiedstate_dir}/Sphinx3Loader.java"
	      tofile="${model_class_dir}/${my_model_name}/ModelLoader.java"/>
	<replace file="${model_class_dir}/${my_model_name}/ModelLoader.java"
	     value="package edu.cmu.sphinx.model.acoustic.${my_model_name}">
	    <replacetoken>package edu.cmu.sphinx.linguist.acoustic.tiedstate</replacetoken>
	</replace>
	<replace file="${model_class_dir}/${my_model_name}/ModelLoader.java"
	         value="ModelLoader">
	    <replacetoken>Sphinx3Loader</replacetoken>
	</replace>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Builds the acoustic model files.                       * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="create_all_models"
	    description="Creates the acoustic model JARS.">
	<antcall target="create_my_model">
	<param name="my_model_data_dir" value="${newAcousticModel_data_dir}"/>
	<param name="my_model_name" value="${newAcousticModel_name}"/>
	</antcall>
    </target>


    <!-- ********************************************************** -->
    <!-- *                                                        * -->
    <!-- * Builds an acoustic model JAR.                          * -->
    <!-- * params: 'my_model_name' and 'my_model_data_dir'        * -->
    <!-- * 1) Copies everything in 'my_model_data_dir' to         * -->
    <!-- *    ${build_model_dir}/${my_model_name}.                * -->
    <!-- * 2) Jars up the ${build_model_dir}/${my_model_name} dir * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** -->
    <target name="create_my_model"
            depends="compile_src"
	    description="Creates an acoustic model JAR.">	    

        <copy todir="${build_model_dir}/${my_model_name}">
	      <fileset dir="${my_model_data_dir}"/>
        </copy>

	<jar destfile="${lib_dir}/${my_model_name}.jar">
	     <fileset dir="${build_dir}/models"
	      includes="edu/cmu/sphinx/model/acoustic/${my_model_name}/*.class"/>
             <fileset dir="${build_dir}/models"
	          includes="edu/cmu/sphinx/model/acoustic/${my_model_name}/**"
		  excludes="edu/cmu/sphinx/model/acoustic/${my_model_name}/*.class"/>
             <manifest>
	        <attribute name="Main-Class"
		 value="edu.cmu.sphinx.model.acoustic.${my_model_name}.PropertiesDumper"/>
		<attribute name="Class-Path" value="sphinx4.jar"/>
             </manifest>
        </jar>
    </target>

    <!-- ********************************************************** --> 
    <!-- *                                                        * -->
    <!-- * Deletes all build output and *~ file droppings         * -->
    <!-- *                                                        * -->
    <!-- ********************************************************** --> 
    <target name="clean" description="Delete all build output">
        <antcall target="clean_not_deploy"/>
	<delete dir="${deploy_dir}"/>
    </target>

    <target name="clean_not_deploy"
            description="Delete all build output except for the deploy dir">
	<delete>
	    <fileset defaultexcludes="no" dir="." includes="**/*~"/>
	</delete>
	<delete dir="${build_dir}"/>
	<delete dir="${bin_dir}"/>
	<delete file="${lib_dir}/sphinx4.jar"/>
	<delete file="tempKeystore"/>
	<antcall target="delete_all_model_classes"/>
    </target>

</project>
"""
