#! /usr/bin/python

## trefnydd_gui.py
## Copyright (C) 2007 Ivan Uemlianin
## Contact: ivan@llaisdy.com
## 
## This file is part of Trefnydd.
##
## Trefnydd is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## Trefnydd is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Trefnydd (i.e., doc/gpl.txt); if not, write to the Free Software
## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
## or see http://www.gnu.org/licenses/gpl.txt


"""
========
trefnydd
========

Package:   trefnydd
Module:    trefnydd_gui
Copyright: 2007 Ivan A. Uemlianin
Contact:   ivan@llaisdy.com
Licence:   GNU GPL (see doc/gpl.txt)

trefnydd_gui
============

The point of this module is to be a 'portable' script that can be used to start up the Trefnydd GUI.  If Trefnydd is installed into site-packages (or to a location which is automatically included in python's path) then this script can be copied/linked/shortcutted to any location and used.  Otherwise, the script should be started from its home at the top of the Trefnydd directory tree.

* changelog:

** 071116

module created.

"""

import os, sys
import wx

# in case trefnydd not installed in python_path
trefnydd_root = os.path.dirname(os.getcwd())
if trefnydd_root not in sys.path:
    sys.path.append(trefnydd_root)

from trefnydd.gui.trefnyddFrame import TrefnyddFrame

def main(projName='', debug=False):
    app = wx.PySimpleApp(redirect=True)
    frm = TrefnyddFrame(None, projName, debug)
    frm.SetSize((800,600))
    frm.Show()
    app.MainLoop()


if __name__ == '__main__':
    main()
 
